#include "mqttFabAcademy.h"
#include <Wire.h>

#define I2C_DEV_ADDR 0x09

void setup() {
  Serial.begin(115200);           // start serial for output
  Serial.println("init setup...");
  
  setup_wifi();
  
  //MQTT
  setupMqttClient();
  mqttReconnect();
  mqttSubscribeTopic(mqttOLEDTopic);
  mqttPublishMessage(mqttServerStatus, "OLED Connected.");
  Serial.println("MQTT ready.");
  
  Wire.begin(I2C_DEV_ADDR);                // join i2c bus with address #9
  Wire.onRequest(requestEvent); // register event
  
  Serial.println("LED slave sender ready.");
}

void loop() {
  //handle MQTT messages
  if(handleMQTTClient()){
    //reconnected, subscribe again
    mqttSubscribeTopic(mqttOLEDTopic);
    // inform server wemos is re-connected
    mqttPublishMessage(mqttServerStatus, "OLED RE-Connected.");
  }
  delay(100);
}

// function that executes whenever data is requested by master
// this function is registered as an event, see setup()
void requestEvent() {
  int sendI2C = -1;
  if(msgReceived.length() > 0){
    sendI2C = msgReceived.toInt();
  }
  Wire.write(sendI2C); // send int value received by MQTT or -1
  // as expected by master
  Serial.printf("Info sent: %d\n", sendI2C);
}
