#include <Wire.h>
#include <VL53L0X.h>  //sensor library

#define SDA_PIN PB0
#define SCL_PIN PB2
#define LED_PIN PB3
#define I2C_DEV_ADDR 0x08

VL53L0X sensor; //reference to the sensor

void blink_led(){
  digitalWrite(LED_PIN, HIGH);
  delay(200);
  digitalWrite(LED_PIN, LOW);
  delay(200);
}
void blink_led_n(int n){
  for(int i = 0; i < n; ++i){
    blink_led();
  }
}

void setup_sensor(){
  if (!sensor.init())
  {
    while (1) {
      blink_led_n(3);
      delay(1000);
    }
  }
  sensor.setTimeout(500);
  sensor.startContinuous();
}

void setup() {
  pinMode(LED_PIN, OUTPUT);
  Wire.begin(); // join i2c bus (address optional for master)
  setup_sensor();
  blink_led_n(3);
  delay(1000);
}

void loop() {
  //read distance from the sensor
  int s_val = sensor.readRangeContinuousMillimeters();
  int distance = s_val / 10;
  if(distance < 10){
    digitalWrite(LED_PIN, HIGH);
  }
  else{
    digitalWrite(LED_PIN, LOW);
  }
  
  Wire.beginTransmission(I2C_DEV_ADDR); // transmit to device #8
  Wire.write(distance);      // sends distance over I2C (1 bytes)
  Wire.endTransmission();    // stop transmitting

  delay(1000);
}
